Subject: Re: Understanding what's going on when using a Huawei E173 USB 3G web-stick (UMTS/HSPA)

From: Greg KH <[email-masked]>
Date: Sat, 15 Nov 2014 18:34:23 -0800

On Sun, Nov 16, 2014 at 02:40:15AM +0100, Sedat Dilek wrote:
> On Sat, Nov 15, 2014 at 9:07 PM, Greg KH <[email-masked]> wrote:
> > On Sat, Nov 15, 2014 at 10:23:55AM +0100, Sedat Dilek wrote:
> >> On Fri, Nov 14, 2014 at 5:18 PM, Dan Williams <[email-masked]> wrote:
> >> > On Fri, 2014-11-14 at 11:56 +0100, Sedat Dilek wrote:
> >> >> On Wed, Nov 12, 2014 at 2:21 PM, Sedat Dilek <[email-masked]> wrote:
> >> >> > On Tue, Nov 4, 2014 at 5:55 PM, Dan Williams <[email-masked]> wrote:
> >> >> >> On Tue, 2014-11-04 at 16:11 +0100, Sedat Dilek wrote:
> >> >> >>> Hi,
> >> >> >>>
> >> >> >>> I wanted to understand what is going on the kernel-side when
> >> >> >>> connecting to the Internet via a Huawei E173 USB web-stick (3rd
> >> >> >>> Generation: UMTS / HSPA).
> >> >> >>>
> >> >> >>> Especially the correlation between the diverse USB/NET kernel-drivers
> >> >> >>> and how the networking is setup.
> >> >> >>
> >> >> >
> >> >> > [ Sitting in front of a foreign Windows machine ]
> >> >> >
> >> >> > [ CC Aleksander ]
> >> >> >
> >> >> > Hi Dan,
> >> >> >
> >> >> > sorry for the late (and short) response.
> >> >> >
> >> >> > AFAICS you have given a "skeleton" for a "usb-wwan-networking"
> >> >> > documentation :-).
> >> >> >
> >> >> > Personally, I would like to take into account some kernel-config
> >> >> > options and some more things.
> >> >> >
> >> >>
> >> >> I started with documenting...
> >> >>
> >> >> I have still some difficulties in understanding USB WWAN Networking.
> >> >> So, this is what I revealed...
> >> >>
> >> >> ##### USB: HUAWEI E173 3G/UMTS/HSPA INTERNET STICK
> >> >>
> >> >> ### USB-NETWORKING AND WWAN SETUP
> >> >> CONFIG_USB_USBNET=m        <--- usb networking
> >> >> CONFIG_USB_NET_CDCETHER=m  <--- usb-wwan (net) configuration
> >> >> CONFIG_USB_SERIAL_WWAN=m   <--- usb-wwan (serial) configuration
> >> >> CONFIG_USB_SERIAL_OPTION=m <--- usb-serial driver called "option"
> >> >
> >> > Most WWAN devices actually require option, because most WWAN devices
> >> > have "serial" ports (even if they aren't used for PPP), and 'option' is
> >> > the driver that handles this.  The 'option' name is historic, but the
> >> > driver should really be called something like 'wwan-serial-generic' or
> >> > something like that.
> >> >ö"
> >>
> >> Is there sth. against renaming the "option" driver to "wwan-serial-generic"?
> >
> > Yes, people's scripts might break that are hard-coded to use the
> > "option" driver.
> >
> 
> As far as I read on LKML... breaking userspace is a reason not to do
> such changes.

Exactly.

> That's really a reason not to break "handmade" scripts on some machines?

Yes.

> As this is new to me... is that documented?

It's our "culture" :)

> Surely, it's fretful to change scripts, but life is change.
> For me there is a more reasonable thing... Did you grep for "option"
> pattern in the kernel sources?
> Try.... :-).

Oh I know, I wrote the first version of this driver and named it this :)

> > greg "here, have a vowel, they are cheap" k-h
> 
> Hmm, being a non-English native, I am not sure to get this...
> What about languages from mostly Eastern countries having so much
> consonants in a single word like Russian, Polish, etc.
> Not every language is rich like German which has WOWels like "ä" (ae)
> "ö" (oe) "ü" (ue).

I was referring to your "sth." abbreviation above.

thanks,

greg k-h